export default {
  namespace: 'main',
  state: {
    nowFlage:"X",
    list: [
      {
        value:1,
        flage:null,
      },{
        value:2,
        flage:null,
      },{
        value:3,
        flage:null,
      },{
        value:4,
        flage:null,
      },{
        value:5,
        flage:null,
      },{
        value:6,
        flage:null,
      },{
        value:7,
        flage:null,
      },{
        value:8,
        flage:null,
      },{
        value:9,
        flage:null,
      }],
    num:0,
    actionData:[],
    gameStatus:false,
    winer:null
  },
  reducers: {
    updateFlage(state,action) {
        return {
          ...state,
          nowFlage:action.flage,
          gameStatus:true
        }
      },
    updateSelectOne(state,action) {
        return {
          ...state,
          list:action.list
        }
    },
    updateAction(state,action) {
      return {
        ...state,
        actionData:action.actionData,
        num:action.num
      }
    },
    updayeRenderData(state,action) {
      return {
        ...state,
        list:action.renderList,
        actionData:action.actionData,
        num:action.num,
        gameStatus:action.gameStatus,
      }
    },
    updateWiner(state,action) {
      return {
        ...state,
        winer:action.winer,
        gameStatus:false
      }
    }
  },
  effects: {
    // 更新对象
    *updateObjFn({id,flage,datasource},{call,put,select}) {
      // 更新当前点击的对象的标记
      let tempArry=JSON.parse(JSON.stringify(datasource))
      let index= tempArry.findIndex((item,index)=>{ return item.value === id})
      tempArry[index].flage=flage
      yield put({
        type:"updateSelectOne",
        list:tempArry
      })
      // 更新全局的标记
      yield put({
        type:'updateFlage',
        flage:flage==="X"?"O":"X"
      })
    },
    // 保存每一步的操作
    *saveActionFn({num,id,flage,list,actionData},{call,put,select}) {
      num = num+1
      let tempArry = JSON.parse(JSON.stringify(list)) // 深拷贝
      let index = tempArry.findIndex((item,index) => { return item.value === id})
      tempArry[index].flage = flage
      actionData.push({
        key:num,
        value:tempArry
      })
      // console.log("actionData",actionData)
      yield put({
        type:'updateAction',
        num:num,
        actionData:actionData
      })
    },
    // 回退操作
    *updateRenderDataFn({flage,key,actionData,list},{call,put,select}) {
      let tempList=JSON.parse(JSON.stringify(actionData))
      let tempData = []
      let tempActionData=[]
      let num = 0
      let gameStatus = true
      if(!flage) {
        let index = tempList.findIndex((item,index)=>{return item.key === key})
        tempData = tempList.find((item,index)=>{return item.key === key}).value
        tempActionData = tempList.slice(0,index+1)
        num = index+1
      }else{
        tempData = list.map((item,index)=>{
          let temp={}
          temp.value = item.value
          temp.flage = null
          return temp
        })
        num = 0
        gameStatus = false
      }
      yield put({
        type:'updayeRenderData',
        renderList:tempData,
        actionData:tempActionData,
        num:num,
        gameStatus:gameStatus,
      })
    },
    // 更新获胜者
    *updateWinerFn({winer},{call,put,select}) {
      yield put({
        type:"updateWiner",
        winer:winer
      })
    }
  },
  subscriptions: {

  },
};
